<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::DataQueueEntry_&lt; U &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1DataQueueEntry__.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1DataQueueEntry__-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::DataQueueEntry_&lt; U &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This base class defines the interface for a DataQueue.  
 <a href="classOpenSim_1_1DataQueueEntry__.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aaa4fb6e139d53de882fdc9c8a67010e2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#aaa4fb6e139d53de882fdc9c8a67010e2">DataQueueEntry_</a> (double timeStamp, const SimTK::RowVectorView_&lt; U &gt; &amp;data)</td></tr>
<tr class="separator:aaa4fb6e139d53de882fdc9c8a67010e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c8046e5eb516646488172b2fe594855"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#a2c8046e5eb516646488172b2fe594855">DataQueueEntry_</a> (const <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> &amp;other)=default</td></tr>
<tr class="separator:a2c8046e5eb516646488172b2fe594855"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1b870901193cbf6e7a73115c61a3a0f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#ae1b870901193cbf6e7a73115c61a3a0f">DataQueueEntry_</a> (<a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> &amp;&amp;)=default</td></tr>
<tr class="separator:ae1b870901193cbf6e7a73115c61a3a0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a657c827f35523b8633fb8f69a66552fa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#a657c827f35523b8633fb8f69a66552fa">operator=</a> (const <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> &amp;)=default</td></tr>
<tr class="separator:a657c827f35523b8633fb8f69a66552fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97fbd5828425cf4b0f9d9086e8b9aad0"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#a97fbd5828425cf4b0f9d9086e8b9aad0">~DataQueueEntry_</a> ()</td></tr>
<tr class="separator:a97fbd5828425cf4b0f9d9086e8b9aad0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abec74ca0627546f8c896af7779a150e4"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#abec74ca0627546f8c896af7779a150e4">getTimeStamp</a> () const</td></tr>
<tr class="separator:abec74ca0627546f8c896af7779a150e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4283ac8fd94899ed324cbaaadb475273"><td class="memItemLeft" align="right" valign="top">SimTK::RowVectorView_&lt; U &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html#a4283ac8fd94899ed324cbaaadb475273">getData</a> () const</td></tr>
<tr class="separator:a4283ac8fd94899ed324cbaaadb475273"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;class U&gt;<br />
class OpenSim::DataQueueEntry_&lt; U &gt;</h3>

<p>This base class defines the interface for a DataQueue. </p>
<p>A data structure to maintain a queue of data to be passed between computations that are potentially different in processing speeds, decoupling the producers (e.g. File or live stream) from consumers.</p>
<p>Synchronization mechanism will be implmented later to allow handling of multiple threads or significant differences in speeds.</p>
<dl class="section author"><dt>Author</dt><dd>Ayman Habib Template class to contain Queue Entries, typically timestamped </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aaa4fb6e139d53de882fdc9c8a67010e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa4fb6e139d53de882fdc9c8a67010e2">&#9670;&nbsp;</a></span>DataQueueEntry_() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::<a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>timeStamp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::RowVectorView_&lt; U &gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a2c8046e5eb516646488172b2fe594855"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c8046e5eb516646488172b2fe594855">&#9670;&nbsp;</a></span>DataQueueEntry_() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::<a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a>&lt; U &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ae1b870901193cbf6e7a73115c61a3a0f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1b870901193cbf6e7a73115c61a3a0f">&#9670;&nbsp;</a></span>DataQueueEntry_() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::<a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a>&lt; U &gt; &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a97fbd5828425cf4b0f9d9086e8b9aad0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97fbd5828425cf4b0f9d9086e8b9aad0">&#9670;&nbsp;</a></span>~DataQueueEntry_()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::~<a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a4283ac8fd94899ed324cbaaadb475273"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4283ac8fd94899ed324cbaaadb475273">&#9670;&nbsp;</a></span>getData()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">SimTK::RowVectorView_&lt;U&gt; <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::getData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1DataQueue__.html#a5d030a34c6650285a655b5bc6273723f">OpenSim::DataQueue_&lt; SimTK::Rotation &gt;::pop_front()</a>.</p>

</div>
</div>
<a id="abec74ca0627546f8c896af7779a150e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abec74ca0627546f8c896af7779a150e4">&#9670;&nbsp;</a></span>getTimeStamp()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::getTimeStamp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1DataQueue__.html#a5d030a34c6650285a655b5bc6273723f">OpenSim::DataQueue_&lt; SimTK::Rotation &gt;::pop_front()</a>.</p>

</div>
</div>
<a id="a657c827f35523b8633fb8f69a66552fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a657c827f35523b8633fb8f69a66552fa">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a>&amp; <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">OpenSim::DataQueueEntry_</a>&lt; U &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a>&lt; U &gt; &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/DataQueue.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1DataQueueEntry__.html">DataQueueEntry_</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:20 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
